<template>
  <v-dialog 
    v-model="visible" 
    persistent 
    max-width="500px">
    <v-card>
      <v-card-title class="headline error-text">Upload Files<v-spacer/>
        <upload-button 
          :selected-callback="selectedCallback" 
          :accept="accept" 
          :multiple="multiple" 
          color="success"
          round>
          Add
        </upload-button>
      </v-card-title>
      
      <v-card-text>
        <v-list 
          v-if="data.files.length > 0" 
          two-line>
          <template v-for="(file, index) in data.files">
            <v-list-tile 
              :key="index"
              avatar>
              <v-list-tile-avatar>
                <v-icon x-large>insert_drive_file</v-icon>
              </v-list-tile-avatar>

              <v-list-tile-content>
                <v-list-tile-title v-html="file.name"/>
              </v-list-tile-content>

              <v-list-tile-action>
                <v-tooltip left>
                  <v-btn 
                    slot="activator" 
                    icon 
                    ripple
                    @click.prevent="removeFile(file)"
                  >
                    <v-icon color="red lighten-1">delete</v-icon>
                  </v-btn>
                  <span>Remove</span>
                </v-tooltip>
              </v-list-tile-action>
            </v-list-tile>

            <v-divider 
              v-if="index + 1 < data.files.length" 
              :key="`divider-${index}`"/>
          </template>
        </v-list>

        <div v-else>
          <v-container text-xs-center>
            <span>Click on the ADD button to add some files</span>
          </v-container>
        </div>

      </v-card-text>

      <v-card-actions>
        <v-spacer/>
        <v-btn 
          flat 
          @click.native="close">Cancel</v-btn>
        <v-btn 
          :disabled="!valid" 
          color="primary" 
          flat 
          @click.native="submit">Upload</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import {bus} from '@js/bus'

import UploadButton from '@components/UploadButton.vue'

export default {

	components: {
		UploadButton
	},

	props: {
		//selectedCallback: Function,
		accept: {
			type: String,
			default: ''
		},
		multiple: {
			type: Boolean,
			default: false
		},
    maxFileSize: {
      type: Number,
      default: window.max_file_size
    },
    maxFileUploads: {
      type: Number,
      default: window.max_file_uploads
    }
	},

	data() {
		return {
			visible: false,
		  data: {
		  	files: [],
		   	parent_id: null
		  },
      errors: false,
      validation: []
		}
	},

	created() {
		bus.$on('upload-files', this.show)
	},

	beforeDestroy() {
		bus.$off('upload-files', this.show)
	},

	methods: {
		show(data) {
      this.data.errors = false
			this.data.parent_id = data.parent_id
			this.data.files = []
			this.visible = true
      this.validation = []

      console.log('max-file-size', window.max_file_size)

			bus.$emit('clear-upload-button')
		},

		submit() {
			this.$emit('submit', this.data)
			this.close()
		},

		close() {
			this.visible = false
		},

		selectedCallback(files) {
			
      		for( var i = 0; i < files.length; i++ ){

          		var is_unique = true
          		for( var j = 0; j < this.data.files.length; j++ ) {
          			if(this.data.files[j].name == files[i].name) {
          				is_unique = false
          				break
          			}
          		}
          		if(is_unique)
          			this.data.files.push( files[i] )
        	}

          this.errors = false

          for(let i in this.data.files) {
            let file = this.data.files[i]
            if(file.size > this.maxFileSize) {
              this.errors = true
              console.log('File size too big:', file)
            }
          }
		},

		removeFile(file) {
			const updated = this.data.files.filter( f => f.name !== file.name )
			this.data.files = updated
			bus.$emit('clear-upload-button')
		}
	},

  computed: {
    valid() {
      return !this.errors && (this.data.files.length > 0)
    }
  },


}
</script>